#import "fontawesome.typ": fa, globe, github, linkedin, envelope
#import "lib.typ": template, work_entry, project, indent, SMALL_STRONG, DEFAULT_STRONG

// orange!!
#let color = blue // rgb("#ff983e")
#let name = "Daniel Chen"

#let contact_data = ((
  service: fa[#globe],
  display: "eggworld.me",
  link: "https://eggworld.me",
), (
  service: fa[#github],
  display: "github.com/potatoeggy",
  link: "https://github.com/potatoeggy",
), (
  service: fa[#linkedin],
  display: "linkedin.com/in/potatoeggy",
  link: "https://www.linkedin.com/in/potatoeggy/",
), (
  service: fa[#envelope],
  display: "d7chen@uwaterloo.ca",
  link: "mailto://d7chen@uwaterloo.ca",
),)

#show: doc => template(name, contact_data, color, doc)

// MAIN CONTENT STARTS here

= Skills

#indent[
  *Languages:* Python, TypeScript, JavaScript, Rust, Java, HTML, CSS, SQL \
  // MATLAB, Dart, Ruby
  *Frameworks:* Node.js, Express, Axum, Spring Boot, React, Next.js, Vue, Flutter,
  Prisma \
  // Qt, Jest / Pytest, Apollo, Prisma, Rails
  *Tools:* Linux, Git, Docker, Terraform, PostgreSQL, AWS/GCP, OpenTelemetry,
  Kubernetes, GraphQL, nginx // Jenkins, systemd, Jira
]

= Experience

#indent[
  #work_entry(
    "Backend Lead & Event Organiser",
    "Hack the North",
    start_date: "Mar 2023",
    end_date: "present",
    location: "Waterloo, ON",
    tools: "Express, GraphQL, Docker, Kubernetes",
    tasks: (
      [??? leadership],
      [Streamlined event check-in times by *80%* for *1900+ attendees* by generating
        digital wallet passes over *Express*],
      [Integrated backend *tracing* to monitor performance and trigger alerts with
        *OpenTelemetry* and *Grafana*],
      [Diagnosed system scaling issues during load spikes and *recovered from a system
        crash* by asking the frontend team to debounce their queries, implementing rate
        limiting as a temporary stopgap measure],
      [Shipped a new *bus registration tool* for attendees by creating new database
        tables and *GraphQL* resolvers],
    ),
  )

  #work_entry(
    "Software Developer Intern",
    "Immigr8",
    start_date: "Jan 2024",
    end_date: "Apr 2024",
    location: "Clearwater, FL",
    tools: "Next.js, Spring Boot, PostgreSQL, AWS, Terraform",
    tasks: (
      [??? deduplicated user form inputs by implementing aws textract w/s3 + lambda],
      // [Improved client responsiveness by *80* by employing stale-while-revalidate hooks for caching and ?? SWR performance, caching, error handling],
      [Set up CI/CD for AWS infrastructure by *codifying it in Terraform* for
        reproducible and automatic deployments],
      [Reduced CI/CD pipeline build times by *70%* by setting up a staging environment
        with *EC2* and *Jenkins*, parallelising builds, and caching dependencies],
      [Planned and executed a roadmap to SOC 2 security compliance by *implementing
        role-based permissions with JWTs*, sending backend logs and alerts to
        *CloudWatch*, and introducing new privacy controls for user data],
    ),
  )

  #work_entry(
    "Software Engineering Intern",
    "Dropbase",
    start_date: "May 2023",
    end_date: "Aug 2023",
    location: "Toronto, ON",
    tools: "React, FastAPI, PostgreSQL, AWS",
    tasks: (
      [Designed a conflict resolution algorithm for merging databases, *reducing
        unrecoverable errors by 75%*],
      [Owned and launched a HubSpot/Airtable to Google Sheets sync feature to *46000+
        enterprise users* by writing *AWS Lambda* functions in Python, abstracting
        interfaces to easily support future sources],
      [Wrote and deployed a new *React* data query builder for our business
        intelligence visualisation service to *33000+ users*, eliminating the need for
        clients to manually write API calls or Python code],
      [Developed a scalable microservice that asynchronously ingests email attachments
        directly into ETL pipelines],
      // [??? emphasise test driven development or remove line *Reduced request errors by 30%* by creating backend testing infrastructure with
      //   *Pytest* to catch regressions and test new features across database engines with
      //   *90% code coverage*],
    ),
  )

  #work_entry(
    "Technical Volunteer",
    "Organization for Transformative Works",
    start_date: "Feb 2024",
    end_date: "present",
    location: "Remote",
    tools: "Ruby on Rails, React, MySQL",
    tasks: (
      [??? Automated importing NUMBER of fics by scraping it into a database then
        import to AO3, largest fanfic archive],
      [?? Increased reliability probably (how?)],
    ),
  )
]

= Projects
#set strong(delta: SMALL_STRONG)

// joycond-cemuhook?

#indent[
  // #project("Comic Downloader", "Python, Qt",
  // repo_link: "https://github.com/potatoeggy/mandown")
  // - Created a CLI and GUI to scrape, download, and convert webcomics into
  //   e-ink-optimised ebooks (EPUB, PDF)
  // - Designed an *intermediate representation* to store metadata and images as a
  //   standardised conversion target
  // - Implemented *image caching and multiprocessing* to increase download and update
  //   speeds by *300%*

  #project(
    "Genshin Simulator",
    "Vue, TypeScript",
    repo_link: "https://github.com/potatoeggy/primoprod",
    demo_link: "https://primoprod.vercel.app",
  )
  - Built a realistic and beautiful *loot box simulator* with fluid animations based
    off a popular game
  - Reduced action latency by *90%* by lazily loading art assets at opportune times,
    such as during cutscenes

  #project(
    "Kobo Sync Server",
    "Rust, Axum",
    repo_link: "https://github.com/potatoeggy/kobink",
  )
  - Developed an Axum backend to *automatically convert and sync* ebooks to a Kobo
    eReader over the network
  - *Reverse-engineered* the Kobo eReader Sync API to support updating ebook
    metadata and covers

  // #project(
  //   "RecipeReady",
  //   "https://github.com/vincentjguo/recipeready-server",
  //   "Flutter, Selenium, FastAPI, Android",
  // )
  // - Developed a *Flutter app* to generate recipes based on ingredients and filters
  //   through a FastAPI server
  // - Scraped thousands of websites for recipes to build a database with a robust
  //   *many-to-many tag system*
  // - Aggregated common ingredients heuristically to build a shopping list and a meal
  // plan for each week

  // #project("Arch Linux Server", "Linux, Docker, nginx, systemd", demo_link: "https://eggworld.me")
  // - Created a *self-hosted CI/CD pipeline* with *Gitea* to automatically deploy
  //   personal projects behind *nginx*
  // - Containerised services with *Docker* and *systemd* to simplify deployment and
  //   management

  // #project(
  //   "Game Boy Advance Emulator",
  //   "Rust, SDL2, Vulkan",
  //   repo_link: "https://github.com/potatoeggy/gbarr",
  // )
  // - Implemented a *ARMv7 emulator* for old games to run on modern x86_64 platforms
  //   with *SDL2* and *Vulkan*
  // - WebGPU and WASM for portability, typestate to guarantee everything is always
  //   valid
]

= Education

#indent[
  #work_entry(
    "University of Waterloo",
    "B.A.Sc. in Computer Engineering",
    start_date: "Sep 2022",
    end_date: "Apr 2027",
    location: "Waterloo, ON",
    tasks: (
      // [Courses: Object-oriented programming, data structures & algorithms, digital
      //   computers & circuits],
      [Extracurriculars: Creative Writing Club, Hack the North, UW Orbital Design Team],
    ),
  )
]
